JUCE: GZIPDecompressorInputStream Class Reference

JUCE

Public Types | Public Member Functions | List of all members
GZIPDecompressorInputStream Class Reference

This stream will decompress a source-stream using zlib. More...

Inheritance diagram for GZIPDecompressorInputStream:

## Public Types
enum | Format { zlibFormat = 0, deflateFormat, gzipFormat }

## Public Member Functions
| GZIPDecompressorInputStream (InputStream *sourceStream, bool deleteSourceWhenDestroyed, Format sourceFormat=zlibFormat, int64 uncompressedStreamLength=-1)
| Creates a decompressor stream. More...
| GZIPDecompressorInputStream (InputStream &sourceStream)
| Creates a decompressor stream. More...
| ~GZIPDecompressorInputStream () override
| Destructor. More...
int64 | getPosition () override
| Returns the offset of the next byte that will be read from the stream. More...
bool | setPosition (int64 pos) override
| Tries to move the current read position of the stream. More...
int64 | getTotalLength () override
| Returns the total number of bytes available for reading in this stream. More...
bool | isExhausted () override
| Returns true if the stream has no more data to read. More...
int | read (void *destBuffer, int maxBytesToRead) override
| Reads some data from the stream into a memory buffer. More...
Public Member Functions inherited from InputStream
virtual | ~InputStream ()=default
| Destructor. More...
int64 | getNumBytesRemaining ()
| Returns the number of bytes available for reading, or a negative value if the remaining length is not known. More...
ssize_t | read (void *destBuffer, size_t maxBytesToRead)
virtual char | readByte ()
| Reads a byte from the stream. More...
virtual bool | readBool ()
| Reads a boolean from the stream. More...
virtual short | readShort ()
| Reads two bytes from the stream as a little-endian 16-bit value. More...
virtual short | readShortBigEndian ()
| Reads two bytes from the stream as a little-endian 16-bit value. More...
virtual int | readInt ()
| Reads four bytes from the stream as a little-endian 32-bit value. More...
virtual int | readIntBigEndian ()
| Reads four bytes from the stream as a big-endian 32-bit value. More...
virtual int64 | readInt64 ()
| Reads eight bytes from the stream as a little-endian 64-bit value. More...
virtual int64 | readInt64BigEndian ()
| Reads eight bytes from the stream as a big-endian 64-bit value. More...
virtual float | readFloat ()
| Reads four bytes as a 32-bit floating point value. More...
virtual float | readFloatBigEndian ()
| Reads four bytes as a 32-bit floating point value. More...
virtual double | readDouble ()
| Reads eight bytes as a 64-bit floating point value. More...
virtual double | readDoubleBigEndian ()
| Reads eight bytes as a 64-bit floating point value. More...
virtual int | readCompressedInt ()
| Reads an encoded 32-bit number from the stream using a space-saving compressed format. More...
virtual String | readNextLine ()
| Reads a UTF-8 string from the stream, up to the next linefeed or carriage return. More...
virtual String | readString ()
| Reads a zero-terminated UTF-8 string from the stream. More...
virtual String | readEntireStreamAsString ()
| Tries to read the whole stream and turn it into a string. More...
virtual size_t | readIntoMemoryBlock (MemoryBlock &destBlock, ssize_t maxNumBytesToRead=-1)
| Reads from the stream and appends the data to a MemoryBlock. More...
virtual void | skipNextBytes (int64 numBytesToSkip)
| Reads and discards a number of bytes from the stream. More...

## Additional Inherited Members
Protected Member Functions inherited from InputStream
| InputStream ()=default

## Detailed Description

This stream will decompress a source-stream using zlib.

Tip: if you're reading lots of small items from one of these streams, you can increase the performance enormously by passing it through a BufferedInputStream, so that it has to read larger blocks less often.

See also
  GZIPCompressorOutputStream

## Member Enumeration Documentation

## ◆ Format

enum GZIPDecompressorInputStream::Format

Enumerator
zlibFormat |
deflateFormat |
gzipFormat |

## Constructor & Destructor Documentation

## ◆ GZIPDecompressorInputStream() [1/2]

GZIPDecompressorInputStream::GZIPDecompressorInputStream | ( | InputStream * | sourceStream,
|  | bool | deleteSourceWhenDestroyed,
|  | Format | sourceFormat = `zlibFormat`,
|  | int64 | uncompressedStreamLength = `-1`
| ) |  |

Creates a decompressor stream.

Parameters

  sourceStream | the stream to read from
  deleteSourceWhenDestroyed | whether or not to delete the source stream when this object is destroyed
  sourceFormat | can be used to select which of the supported formats the data is expected to be in
  uncompressedStreamLength | if the creator knows the length that the uncompressed stream will be, then it can supply this value, which will be returned by getTotalLength()

## ◆ GZIPDecompressorInputStream() [2/2]

GZIPDecompressorInputStream::GZIPDecompressorInputStream | ( | InputStream & | sourceStream | ) |

Creates a decompressor stream.

Parameters

  sourceStream | the stream to read from - the source stream must not be deleted until this object has been destroyed

## ◆ ~GZIPDecompressorInputStream()

GZIPDecompressorInputStream::~GZIPDecompressorInputStream | ( |  | ) |
| override

Destructor.

## Member Function Documentation

## ◆ getPosition()

int64 GZIPDecompressorInputStream::getPosition | ( |  | ) |
| overridevirtual

Returns the offset of the next byte that will be read from the stream.

See also
  setPosition

Implements InputStream.

## ◆ setPosition()

bool GZIPDecompressorInputStream::setPosition | ( | int64 | newPosition | ) |
| overridevirtual

Tries to move the current read position of the stream.

The position is an absolute number of bytes from the stream's start.

Some streams might not be able to do this, in which case they should do nothing and return false. Others might be able to manage it by resetting themselves and skipping to the correct position, although this is obviously a bit slow.

Returns
  true if the stream manages to reposition itself correctly

See also
  getPosition

Implements InputStream.

## ◆ getTotalLength()

int64 GZIPDecompressorInputStream::getTotalLength | ( |  | ) |
| overridevirtual

Returns the total number of bytes available for reading in this stream.

Note that this is the number of bytes available from the start of the stream, not from the current position.

If the size of the stream isn't actually known, this will return -1.

See also
  getNumBytesRemaining

Implements InputStream.

## ◆ isExhausted()

bool GZIPDecompressorInputStream::isExhausted | ( |  | ) |
| overridevirtual

Returns true if the stream has no more data to read.

Implements InputStream.

## ◆ read()

int GZIPDecompressorInputStream::read | ( | void * | destBuffer,
|  | int | maxBytesToRead
| ) |  |
| overridevirtual

Reads some data from the stream into a memory buffer.

This is the only read method that subclasses actually need to implement, as the InputStream base class implements the other read methods in terms of this one (although it's often more efficient for subclasses to implement them directly).

Parameters

  destBuffer | the destination buffer for the data. This must not be null.
  maxBytesToRead | the maximum number of bytes to read - make sure the memory block passed in is big enough to contain this many bytes. This value must not be negative.

Returns
  the actual number of bytes that were read, which may be less than maxBytesToRead if the stream is exhausted before it gets that far

Implements InputStream.

The documentation for this class was generated from the following file:

- juce_GZIPDecompressorInputStream.h